com.corticon.eclipse.core.util

## Class OptimizerUtil

- java.lang.Object
- - com.corticon.eclipse.core.util.OptimizerUtil

-     public class OptimizerUtil
      extends java.lang.Object

  `OptimizerUtil` contains methods intended for the analysis and optimization function, mostly related to the management of sets.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `OptimizerUtil()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.lang.String` | `addBraces(java.lang.String astrSetContents, java.lang.String astrCompleteSet)` Return a set elements with braces.
    `static java.lang.String` | `addBraces(java.lang.String astrSetContents, java.lang.String astrCompleteSet, java.util.Locale aLocale)` Return a set elements with braces.
    `static java.lang.String` | `addNegation(java.lang.String astrExpression)` Add negation to an existing expression.
    `static java.lang.String` | `addNegation(java.lang.String astrExpression, java.util.Locale aLocale)` Add localized negation to an existing expression.
    `static java.lang.String` | `getIntersectionSet(java.lang.String astrSetOne, java.lang.String astrSetTwo, java.lang.String astrCompleteSet)` Return the intersection of two sets, or a dash if the intersection set contains a complete set of values (and the caller supplies the complete set of values; if the caller supplies null, dashes are not processed in any special manner).
    `static java.lang.String` | `getNot(java.util.Locale aLocale)` Return the "not" operator for the specified locale.
    `static java.lang.String` | `getOther(java.util.Locale aLocale)` Return the "other" keyword for the specified locale.
    `static java.lang.String[]` | `getSetArray(java.lang.String astrSetContents, java.lang.String astrCompleteSet)` Return an array consisting of the set of values in a caller-supplied if cell.
    `static java.lang.String[]` | `getSetArray(java.lang.String astrSetContents, java.lang.String astrCompleteSet, java.util.Locale aLocale)` Return an array consisting of the set of values in a caller-supplied if cell.
    `static java.lang.String` | `getSetFromArray(java.lang.String[] astrSetArray, boolean abMinimizeSpaces)` Convert a caller supplied array of Strings to standard set notation.
    `static java.lang.String` | `getSetFromArray(java.lang.String[] astrSetArray, boolean abMinimizeSpaces, java.util.Locale aLocale)` Convert a caller supplied array of Strings to standard set notation.
    `static java.lang.String` | `getSetFromHashSet(java.util.HashSet ahsSet, java.lang.String astrCompleteSet)` Convert a caller supplied HashSet to standard set notation.
    `static java.lang.String` | `getSetFromHashSet(java.util.HashSet ahsSet, java.lang.String astrCompleteSet, java.util.Locale aLocale)` Convert a caller supplied HashSet to standard set notation.
    `static java.lang.String` | `getSetFromVector(java.util.Vector avectSet)` Convert a caller supplied Vector of Strings to standard set notation.
    `static java.lang.String` | `getSetFromVector(java.util.Vector avectSet, boolean abBase)` Convert a caller supplied Vector of Strings to standard set notation.
    `static java.util.HashSet` | `getSetHashSet(java.lang.String astrSetContents, java.lang.String astrCompleteSet)` Return a HashSet consisting of the set of values in a caller-supplied if cell.
    `static java.util.HashSet` | `getSetHashSet(java.lang.String astrSetContents, java.lang.String astrCompleteSet, java.util.Locale aLocale)` Return a HashSet consisting of the set of values in a caller-supplied if cell.
    `static java.lang.String` | `getSetSeparator(java.util.Locale aLocale)` Return the set delimiter for the specified locale.
    `static java.util.StringTokenizer` | `getSetValues(java.lang.String astrSetContents, java.lang.String astrCompleteSet)` Return a StringTokenizer consisting of the set of values in a caller-supplied if cell.
    `static java.util.StringTokenizer` | `getSetValues(java.lang.String astrSetContents, java.lang.String astrCompleteSet, java.util.Locale aLocale)` Return a StringTokenizer consisting of the set of values in a caller-supplied if cell.
    `static java.lang.String[]` | `getSetValuesFromArray(java.lang.String astrSetContents, java.lang.String[] aCompleteSetArray)` Build string representation of full values set and calls existing method to make all calculations.
    `static java.lang.String[]` | `getSetValuesFromArray(java.lang.String astrSetContents, java.lang.String[] aCompleteSetArray, java.util.Locale aLocale)` Build string representation of full values set and calls existing method to make all calculations.
    `static java.util.Vector` | `getSetVector(java.lang.String astrSetContents, java.lang.String astrCompleteSet)` Return a Vector consisting of the set of values in a caller-supplied if cell.
    `static java.util.Vector` | `getSetVector(java.lang.String astrSetContents, java.lang.String astrCompleteSet, java.util.Locale aLocale)` Return a Vector consisting of the set of values in a caller-supplied if cell.
    `static java.util.Vector` | `getStandardSetVector(java.lang.String astrSetContents, java.lang.String astrCompleteSet)` Return a Vector consisting of the set of values in a caller-supplied if cell.
    `static java.util.Vector` | `getStandardSetVector(java.lang.String astrSetContents, java.lang.String astrCompleteSet, boolean lbIgnoreNot)`
    `static java.lang.String` | `getUnionSet(java.lang.String astrSetOne, java.lang.String astrSetTwo, java.lang.String astrCompleteSet)` Return the union of two sets, or a dash if the union set contains a complete set of values (and the caller supplies the complete set of values; if the caller supplies null, dashes are not processed in any special manner).
    `static ValueSet` | `getUnionSet(ValueSet aValueSetOne, ValueSet aValueSetTwo, ValueSet aValueSetComplete)` Return the union of two sets, or a dash if the union set contains a complete set of values (and the caller supplies the complete set of values; if the caller supplies null, dashes are not processed in any special manner).
    `static boolean` | `isDecimalColumn(java.lang.String astrColumnHeader)` Determine whether this is a decimal or integer column header.
    `static boolean` | `isInSet(java.lang.String astrSet, java.lang.String astrValue)` Check value to be presented in the set.
    `static boolean` | `isNegated(java.lang.String astrExpression)` Returns `true` if the expression begins with the not operator.
    `static boolean` | `isNegated(java.lang.String astrExpression, java.util.Locale aLocale)` Returns `true` if the expression begins with the not operator.
    `static boolean` | `isSameSet(java.lang.String astrSetOne, java.lang.String astrSetTwo, java.lang.String astrCompleteSet)` Compare two sets to determine whether they are logically equal.
    `static boolean` | `isSet(java.lang.String astrValue)` Determine whether caller supplied value is a set.
    `static boolean` | `isSubset(java.lang.String astrSetOne, java.lang.String astrSetTwo, java.lang.String astrCompleteSet)` Determine whether one set is a subset of another and return appropriate boolean value.
    `static boolean` | `isSubset(ValueSet aValueSetOne, ValueSet aValueSetTwo, ValueSet aValueSetComplete)` Determine whether one set is a subset of another and return appropriate boolean value.
    `static void` | `mergeSetElements(java.util.StringTokenizer astValues, java.util.HashSet ahsSet)` Merge a caller supplied StringTokenizer of strings into a caller-supplied HashSet.
    `static boolean` | `overlap(ValueSet aValueSetOne, ValueSet aValueSetTwo, ValueSet aValueSetComplete)` Check values for overlap.
    `static java.lang.String` | `removeBraces(java.lang.String astrSetContents, java.lang.String astrCompleteSet)` Return a caller-supplied set of elements without braces (if they're present).
    `static java.lang.String` | `removeNegation(java.lang.String astrExpression)` Remove negation from expression, if any.
    `static java.lang.String` | `removeNegation(java.lang.String astrExpression, java.util.Locale aLocale)` Remove negation from expression, if any.
    `static java.lang.String` | `removeRedundantSetElements(java.lang.String astrSetContents, java.lang.String astrCompleteSet)` Remove redundant set elements from the specified set (if any).
    `static java.lang.String` | `removeRedundantSetElements(java.lang.String astrSetContents, java.lang.String astrCompleteSet, java.util.Locale aLocale)` Remove redundant set elements from the specified set (if any).

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### OptimizerUtil

          public OptimizerUtil()

  - ### Method Detail

    - #### isSet

          public static boolean isSet(java.lang.String astrValue)

      Determine whether caller supplied value is a set.
      Parameters:
        `astrValue` - Value to check.
      Returns:
        `true` if value is a set; otherwise returns false.

    - #### removeRedundantSetElements

          public static java.lang.String removeRedundantSetElements(java.lang.String astrSetContents,
                                                    java.lang.String astrCompleteSet)

      Remove redundant set elements from the specified set (if any).
      Parameters:
        `astrSetContents` - Set from which to eliminate redundant values.
        `astrCompleteSet` - Complete set of values in standard form (if dash possible) or null.
      Returns:
        String with redundant set elements removed.

    - #### removeRedundantSetElements

          public static java.lang.String removeRedundantSetElements(java.lang.String astrSetContents,
                                                    java.lang.String astrCompleteSet,
                                                    java.util.Locale aLocale)

      Remove redundant set elements from the specified set (if any).
      Parameters:
        `astrSetContents` - Set from which to eliminate redundant values.
        `astrCompleteSet` - Complete set of values in standard form (if dash possible) or null.
        `aLocale` - Locale in which input is expressed.
      Returns:
        String with redundant elements removed.

    - #### getUnionSet

          public static java.lang.String getUnionSet(java.lang.String astrSetOne,
                                     java.lang.String astrSetTwo,
                                     java.lang.String astrCompleteSet)

      Return the union of two sets, or a dash if the union set contains a complete set of values (and the caller supplies the complete set of values; if the caller supplies null, dashes are not processed in any special manner). If the caller supplies a complete value set, the elements are returned in the order of the complete value set. If the caller does not supply a complete set, set two is logically concatenated after the end of set one (with duplicates removed from set two).
      Parameters:
        `astrSetOne` - First set (brace-delimited, comma separated values)
        `astrSetTwo` - Second set (brace-delimited, comma separated values)
        `astrCompleteSet` - Complete set of possible values (brace-delimited, comma separated values or null)
      Returns:
        The union of the two sets or dash if the union set contains all possible values

    - #### getUnionSet

          public static ValueSet getUnionSet(ValueSet aValueSetOne,
                             ValueSet aValueSetTwo,
                             ValueSet aValueSetComplete)

      Return the union of two sets, or a dash if the union set contains a complete set of values (and the caller supplies the complete set of values; if the caller supplies null, dashes are not processed in any special manner). If the caller supplies a complete value set, the elements are returned in the order of the complete value set. If the caller does not supply a complete set, set two is logically concatenated after the end of set one (with duplicates removed from set two).
      Parameters:
        `aValueSetOne` - First set.
        `aValueSetTwo` - Second set.
        `aValueSetComplete` - Complete set of possible values.
      Returns:
        The union of the two sets or dash if the union set contains all possible values

    - #### getIntersectionSet

          public static java.lang.String getIntersectionSet(java.lang.String astrSetOne,
                                            java.lang.String astrSetTwo,
                                            java.lang.String astrCompleteSet)

      Return the intersection of two sets, or a dash if the intersection set contains a complete set of values (and the caller supplies the complete set of values; if the caller supplies null, dashes are not processed in any special manner). If the caller supplies a complete value set, the elements are returned in the order of the complete value set. If the caller does not supply a complete set, the intersecting elements are concatenated in the order they appear in the second set.
      Parameters:
        `astrSetOne` - First set (brace-delimited, comma separated values)
        `astrSetTwo` - Second set (brace-delimited, comma separated values)
        `astrCompleteSet` - Complete set of possible values (brace-delimited, comma separated values or null)
      Returns:
        The intersection of the two sets or empty string for the empty set

    - #### isSubset

          public static boolean isSubset(java.lang.String astrSetOne,
                         java.lang.String astrSetTwo,
                         java.lang.String astrCompleteSet)

      Determine whether one set is a subset of another and return appropriate boolean value. The caller can supply the complete set of allowable values, and the function will consider a dash in either of asetSetOne or astrSetTwo to technically represent that complete set. If the caller supplies null, dashes are treated as just dashes (no special meaning).
      Parameters:
        `astrSetOne` - First set (brace-delimited, comma separated values)
        `astrSetTwo` - Second set (brace-delimited, comma separated values)
        `astrCompleteSet` - Complete set of possible values or null
      Returns:
        Indicator of whether first set is a subset of the second set

    - #### isSubset

          public static boolean isSubset(ValueSet aValueSetOne,
                         ValueSet aValueSetTwo,
                         ValueSet aValueSetComplete)

      Determine whether one set is a subset of another and return appropriate boolean value. The caller can supply the complete set of allowable values, and the function will consider a dash in either of asetSetOne or astrSetTwo to technically represent that complete set. If the caller supplies null, dashes are treated as just dashes (no special meaning).
      Parameters:
        `aValueSetOne` - First set.
        `aValueSetTwo` - Second set.
        `aValueSetComplete` - Complete set of possible values or null.
      Returns:
        Indicator of whether first set is a subset of the second set.

    - #### isSameSet

          public static boolean isSameSet(java.lang.String astrSetOne,
                          java.lang.String astrSetTwo,
                          java.lang.String astrCompleteSet)

      Compare two sets to determine whether they are logically equal. The caller can supply the complete set of allowable values, and the function will consider a dash in either of asetSetOne or astrSetTwo to technically represent that complete set. If the caller supplies null, dashes are treated as just dashes (no special meaning).
      Parameters:
        `astrSetOne` - First set (brace-delimited, comma separated values)
        `astrSetTwo` - Second set (brace-delimited, comma separated values)
        `astrCompleteSet` - Complete set of possible values or null
      Returns:
        `true` if both sets are the same

    - #### overlap

          public static boolean overlap(ValueSet aValueSetOne,
                        ValueSet aValueSetTwo,
                        ValueSet aValueSetComplete)

      Check values for overlap. If intersection of value sets is not null - it's overlap.
      Parameters:
        `aValueSetOne` - ValueSet one.
        `aValueSetTwo` - ValueSet two.
        `aValueSetComplete` - The complete set
      Returns:
        `true` if overlap; otherwise return `false`

    - #### isInSet

          public static boolean isInSet(java.lang.String astrSet,
                        java.lang.String astrValue)

      Check value to be presented in the set.
      Parameters:
        `astrSet` - The set of elements to check
        `astrValue` - The value that to search for
      Returns:
        `true` if the value is in the set; otherwise returns `false`

    - #### isDecimalColumn

          public static boolean isDecimalColumn(java.lang.String astrColumnHeader)

      Determine whether this is a decimal or integer column header.
      Parameters:
        `column` - Column header string
      Returns:
        `true` if decimal header; otherwise return `false`

    - #### mergeSetElements

          public static void mergeSetElements(java.util.StringTokenizer astValues,
                              java.util.HashSet ahsSet)

      Merge a caller supplied StringTokenizer of strings into a caller-supplied HashSet.
      Parameters:
        `astValues` - List of values to be merged into Hashset
        `ahsSet` - Hashset to update

    - #### getSetValues

          public static java.util.StringTokenizer getSetValues(java.lang.String astrSetContents,
                                               java.lang.String astrCompleteSet)

      Return a StringTokenizer consisting of the set of values in a caller-supplied if cell. The caller also supplies the complete set, so that if a dash is passed by the caller, this method returns the entire set of values. The input set is expected to be in base form (non-localized).
      Parameters:
        `astrSetContents` - Set (brace-delimited, comma separated values)
        `astrCompleteSet` - Complete set of possible values (brace-delimited, comma separated values)
      Returns:
        StringTokenizer consisting of all values in the set

    - #### getSetValues

          public static java.util.StringTokenizer getSetValues(java.lang.String astrSetContents,
                                               java.lang.String astrCompleteSet,
                                               java.util.Locale aLocale)

      Return a StringTokenizer consisting of the set of values in a caller-supplied if cell. The caller also supplies the complete set, so that if a dash is passed by the caller, this method returns the entire set of values.
      Parameters:
        `astrSetContents` - Set (brace-delimited, comma separated values)
        `astrCompleteSet` - Complete set of possible values (brace-delimited, comma separated values)
        `aLocale` - Locale in which set is expressed.
      Returns:
        StringTokenizer consisting of all values in the set

    - #### getSetVector

          public static java.util.Vector getSetVector(java.lang.String astrSetContents,
                                      java.lang.String astrCompleteSet)

      Return a Vector consisting of the set of values in a caller-supplied if cell. The caller also supplies the complete set, so that if a dash is passed by the caller, this method returns the entire set of values. The input set is expected to be in base form (non-localized).
      Parameters:
        `astrSetContents` - Set (brace-delimited, comma separated values)
        `astrCompleteSet` - Complete set of possible values (brace-delimited, comma separated values)
      Returns:
        Vector consisting of all values in the set

    - #### getSetVector

          public static java.util.Vector getSetVector(java.lang.String astrSetContents,
                                      java.lang.String astrCompleteSet,
                                      java.util.Locale aLocale)

      Return a Vector consisting of the set of values in a caller-supplied if cell. The caller also supplies the complete set, so that if a dash is passed by the caller, this method returns the entire set of values.
      Parameters:
        `astrSetContents` - Set (brace-delimited, comma separated values)
        `astrCompleteSet` - Complete set of possible values (brace-delimited, comma separated values)
        `abBase` - Indicates that input string is supplied in base form
      Returns:
        Vector consisting of all values in the set

    - #### getStandardSetVector

          public static java.util.Vector getStandardSetVector(java.lang.String astrSetContents,
                                              java.lang.String astrCompleteSet)

      Return a Vector consisting of the set of values in a caller-supplied if cell. The caller also supplies the complete set, so that if a dash is passed by the caller, this method returns the entire set of values. In addition, the caller may supply a set that begins with the negation operator (e.g., "not"), in which case there returned Vector will contain the inverse value set. The input set is expected to be in base form (non-localized).
      Parameters:
        `astrSetContents` - Set (brace-delimited, comma separated values)
        `astrCompleteSet` - Complete set of possible values (brace-delimited, comma separated values)
      Returns:
        Vector consisting of all values in the set

    - #### getStandardSetVector

          public static java.util.Vector getStandardSetVector(java.lang.String astrSetContents,
                                              java.lang.String astrCompleteSet,
                                              boolean lbIgnoreNot)

    - #### getSetArray

          public static java.lang.String[] getSetArray(java.lang.String astrSetContents,
                                       java.lang.String astrCompleteSet)

      Return an array consisting of the set of values in a caller-supplied if cell. The caller also supplies the complete set, so that if a dash is passed by the caller, this method returns the entire set of values. The input set is expected to be in base form (non-localized).
      Parameters:
        `astrSetContents` - Set (brace-delimited, comma separated values)
        `astrCompleteSet` - Complete set of possible values (brace-delimited, comma separated values)
      Returns:
        Array consisting of all values in the set

    - #### getSetArray

          public static java.lang.String[] getSetArray(java.lang.String astrSetContents,
                                       java.lang.String astrCompleteSet,
                                       java.util.Locale aLocale)

      Return an array consisting of the set of values in a caller-supplied if cell. The caller also supplies the complete set, so that if a dash is passed by the caller, this method returns the entire set of values.
      Parameters:
        `astrSetContents` - Set (brace-delimited, comma separated values).
        `astrCompleteSet` - Complete set of possible values (brace-delimited, comma separated values)
        `aLocale` - Locale in which input is expressed.
      Returns:
        Array consisting of all values in the set.

    - #### getSetHashSet

          public static java.util.HashSet getSetHashSet(java.lang.String astrSetContents,
                                        java.lang.String astrCompleteSet)

      Return a HashSet consisting of the set of values in a caller-supplied if cell. The caller also supplies the complete set, so that if a dash is passed by the caller, this method returns the entire set of values. The input set is expected to be in base form (non-localized).
      Parameters:
        `astrSetContents` - Set (brace-delimited, comma separated values)
        `astrCompleteSet` - Complete set of possible values (brace-delimited, comma separated values)
      Returns:
        HashSet consisting of all values in the set

    - #### getSetHashSet

          public static java.util.HashSet getSetHashSet(java.lang.String astrSetContents,
                                        java.lang.String astrCompleteSet,
                                        java.util.Locale aLocale)

      Return a HashSet consisting of the set of values in a caller-supplied if cell. The caller also supplies the complete set, so that if a dash is passed by the caller, this method returns the entire set of values.
      Parameters:
        `astrSetContents` - Set (brace-delimited, comma separated values)
        `astrCompleteSet` - Complete set of possible values (brace-delimited, comma separated values)
        `aLocale` - Locale in which set is expressed.
      Returns:
        HashSet consisting of all values in the set

    - #### getSetFromVector

          public static java.lang.String getSetFromVector(java.util.Vector avectSet)

      Convert a caller supplied Vector of Strings to standard set notation. Set will be returned in base (non-localized) form.
      Parameters:
        `avectSet` - Vector of set elements
      Returns:
        String consisting of values in set (e.g., { 3.0 , 3.1 })

    - #### getSetFromVector

          public static java.lang.String getSetFromVector(java.util.Vector avectSet,
                                          boolean abBase)

      Convert a caller supplied Vector of Strings to standard set notation.
      Parameters:
        `avectSet` - Vector of set elements
        `abBase` - Return results in base (non-localized) form
      Returns:
        String consisting of values in set (e.g., { 3.0 , 3.1 })

    - #### getSetFromArray

          public static java.lang.String getSetFromArray(java.lang.String[] astrSetArray,
                                         boolean abMinimizeSpaces)

      Convert a caller supplied array of Strings to standard set notation. Set will be returned in base (non-localized) form.
      Parameters:
        `astrSetArray` - Array of set elements.
        `abMinimizeSpaces` - Perform special formatting with minimal spaces.
      Returns:
        String consisting of values in set (e.g., { 3.0 , 3.1 }).

    - #### getSetFromArray

          public static java.lang.String getSetFromArray(java.lang.String[] astrSetArray,
                                         boolean abMinimizeSpaces,
                                         java.util.Locale aLocale)

      Convert a caller supplied array of Strings to standard set notation.
      Parameters:
        `astrSetArray` - Array of set elements.
        `abMinimizeSpaces` - Perform special formatting with minimal spaces.
        `aLocale` - Locale to use for set delimiter.
      Returns:
        String consisting of values in set (e.g., { 3.0 , 3.1 }).

    - #### getSetFromHashSet

          public static java.lang.String getSetFromHashSet(java.util.HashSet ahsSet,
                                           java.lang.String astrCompleteSet)

      Convert a caller supplied HashSet to standard set notation. Set will be returned in base (non-localized) form.
      Parameters:
        `ahsSet` - HashSet of elements
        `astrCompleteSet` - Complete set for condition in standard set notation
      Returns:
        String consisting of values in set (e.g., { 3.0 , 3.1 })

    - #### getSetFromHashSet

          public static java.lang.String getSetFromHashSet(java.util.HashSet ahsSet,
                                           java.lang.String astrCompleteSet,
                                           java.util.Locale aLocale)

      Convert a caller supplied HashSet to standard set notation.
      Parameters:
        `ahsSet` - Set of elements
        `astrCompleteSet` - Complete set for condition in standard set notation
        `aLocale` - Locale in which to express results.
      Returns:
        String consisting of values in set (e.g., { 3.0 , 3.1 })

    - #### getSetValuesFromArray

          public static java.lang.String[] getSetValuesFromArray(java.lang.String astrSetContents,
                                                 java.lang.String[] aCompleteSetArray)

      Build string representation of full values set and calls existing method to make all calculations.
      Parameters:
        `astrSetContents` - Set contents array
        `astrCompleteSet` - Complete set array
      Returns:
        Array of all values in set

    - #### getSetValuesFromArray

          public static java.lang.String[] getSetValuesFromArray(java.lang.String astrSetContents,
                                                 java.lang.String[] aCompleteSetArray,
                                                 java.util.Locale aLocale)

      Build string representation of full values set and calls existing method to make all calculations.
      Parameters:
        `astrSetContents` - Set contents array
        `astrCompleteSet` - Complete set array
        `aLocale` - Locale in which input is expressed.
      Returns:
        Array of all values in set

    - #### isNegated

          public static boolean isNegated(java.lang.String astrExpression)

      Returns `true` if the expression begins with the not operator.
      Parameters:
        `astrExpression` - Expression to check.
        `aLocale` - Locale in which string is expressed.
      Returns:
        `true` if expression is negated.

    - #### isNegated

          public static boolean isNegated(java.lang.String astrExpression,
                          java.util.Locale aLocale)

      Returns `true` if the expression begins with the not operator.
      Parameters:
        `astrExpression` - Expression to check.
        `aLocale` - Locale in which string is expressed.
      Returns:
        `true` if expression is negated.

    - #### removeNegation

          public static java.lang.String removeNegation(java.lang.String astrExpression)

      Remove negation from expression, if any.
      Parameters:
        `astrExpression` - Original expression.
      Returns:
        Expression with "not" removed, otherwise original expression.

    - #### removeNegation

          public static java.lang.String removeNegation(java.lang.String astrExpression,
                                        java.util.Locale aLocale)

      Remove negation from expression, if any.
      Parameters:
        `astrExpression` - Original expression.
        `aLocale` - Locale which specifies value of "not" to be supplied.
      Returns:
        Expression with "not" removed, otherwise original expression.

    - #### addNegation

          public static java.lang.String addNegation(java.lang.String astrExpression)

      Add negation to an existing expression.
      Parameters:
        `astrExpression` - Original expression.
      Returns:
        Expression with 'not' added.

    - #### addNegation

          public static java.lang.String addNegation(java.lang.String astrExpression,
                                     java.util.Locale aLocale)

      Add localized negation to an existing expression.
      Parameters:
        `astrExpression` - Original expression.
        `aLocale` - Locale which specifies value of "not" to be supplied.
      Returns:
        Expression with localized 'not' added.

    - #### removeBraces

          public static java.lang.String removeBraces(java.lang.String astrSetContents,
                                      java.lang.String astrCompleteSet)

      Return a caller-supplied set of elements without braces (if they're present). Automatically convert dash if present.
      Parameters:
        `astrSetContents` - Value from which to remove braces
        `astrCompleteSet` - Complete set of values in standard form (if dash possible) or null
      Returns:
        String with braces removed

    - #### addBraces

          public static java.lang.String addBraces(java.lang.String astrSetContents,
                                   java.lang.String astrCompleteSet)

      Return a set elements with braces. Automatically convert complete set to dash. Set is expected in base (non-localized) form.
      Parameters:
        `astrSetContents` - String of delimited values to which braces should be added
        `astrCompleteSet` - Complete set of values in standard form (if dash desired) or null
      Returns:
        String with braces added

    - #### addBraces

          public static java.lang.String addBraces(java.lang.String astrSetContents,
                                   java.lang.String astrCompleteSet,
                                   java.util.Locale aLocale)

      Return a set elements with braces. Automatically convert complete set to dash.
      Parameters:
        `astrSetContents` - String of delimited values to which braces should be added
        `astrCompleteSet` - Complete set of values in standard form (if dash desired) or null
        `abBase` - Return results in base (non-localized) form
      Returns:
        String with braces added

    - #### getNot

          public static java.lang.String getNot(java.util.Locale aLocale)

      Return the "not" operator for the specified locale.
      Parameters:
        `aLocale` - Locale for which "not" operator should be returned (Constants.LOCALE_BASE for base).
      Returns:
        Not operator for the specified locale (e.g., "nicht").

    - #### getOther

          public static java.lang.String getOther(java.util.Locale aLocale)

      Return the "other" keyword for the specified locale.
      Parameters:
        `aLocale` - Locale for which "other" keyword should be returned (Constants.LOCALE_BASE for base).
      Returns:
        Other keyword for the specified locale (e.g., "autre").

    - #### getSetSeparator

          public static java.lang.String getSetSeparator(java.util.Locale aLocale)

      Return the set delimiter for the specified locale.
      Parameters:
        `aLocale` - Locale for which set delimiter should be returned (Constants.LOCALE_BASE for base).
      Returns:
        Set delimiter (typically comma or semicolon).

Copyright © 2005-2013 Progress Software Corporation and/or its subsidiaries and affiliates. All rights reserved.